// ApiPrint.cpp : ߃t@C쐬֐
//

#include	"stdafx.h"

#include	"ApiPrint.h"

#include	"SfCsSys.h"

extern "C" {

//**********************************************************************
// ֐        : MakePrintMission
// @\          : ߃t@C쐬
// Ăяo      : MakePrintMission( PRINTFILE_MISSION *pInfo, int *piError )
//           : pInfo   = ߃t@C쐬|C^
//               : piError = G[AG[擾p|C^
// o          : Ԓl  TRUE  : I
//               :       FALSE : s
//               :               *piError = G[R[h
//               : 
//               :   yG[R[hz
//               :       PRINTFILE_ERR_NoMisFolder      ... ߃tH_݂܂
//               :       PRINTFILE_ERR_GetMisFolder     ... ߃tH_̎擾Ɏs܂
//               :       PRINTFILE_ERR_GetTempFolder    ... ꎞtH_̎擾Ɏs܂
//               :       PRINTFILE_ERR_GetTempFile      ... ꎞt@C̎擾Ɏs܂
//               :       PRINTFILE_ERR_MakeMisName      ... ߃t@C̍쐬Ɏs܂
//               :       PRINTFILE_ERR_PARAM_INFO       ... ֐G[: ߃t@C쐬񂪎w肳Ă܂B
//               :       PRINTFILE_ERR_PARAM_DOC        ... ֐G[: et@Cw肳Ă܂B
//               :       PRINTFILE_ERR_PARAM_DOCNAME    ... ֐G[: et@Cw肳Ă܂B
//               : 
// L      :   ߃t@C쐬쐬܂B
// 쐬        : 
// 쐬        : 2001.11.16
//**********************************************************************
BOOL APIENTRY	MakePrintMission( PRINTFILE_MISSION *pInfo, int *piError )
{
	BOOL	bRet = FALSE;	// Ԓl ... l͎s

	int	iErrorDummy;	// NULLp_~[G[R[hݒ

	int	i;

	BOOL	bTemp = FALSE;		// ꎞt@C쐬ꂽۂ

	char	szTempFolder[MAX_PATH+1];	// ꎞt@CtH_p
	char	szTempFile[MAX_PATH+1];		// ꎞt@Cp

	char	szPrintMisFolder[MAX_PATH+1];	// ߃tH_p
	char	szPrintMis[MAX_PATH+1];			// ߃t@Cp

	char	*pDocName;		// ep

	char	szKey[32];		// L[ݒp
	char	szWork[512];	// Ɨp

	if( !piError ) {
		// G[R[h擾p|C^Ƀ_~[ݒ
		piError = &iErrorDummy;
	}
	*piError = PRINTFILE_SUCCESS;		// G[R[hɏlݒ ... I

	/////////////////////////////////////////////////////////////////////////////
	// (1)  ȒPȈ̓e`FbN
	// 

		// ߃t@C쐬`FbN
	if( !pInfo ) {
		*piError = PRINTFILE_ERR_PARAM_INFO;
		goto	EXIT;
	}
		// et@C`FbN
	if( !pInfo->iDocNum ) {
		*piError = PRINTFILE_ERR_PARAM_DOC;
		goto	EXIT;
	}
		// et@C`FbN
	if( pInfo->iDocNum ) {
		for( i = 0 ;  i < pInfo->iDocNum ; i++ ) {
			pDocName = *( pInfo->ppDocName + i );
			if( !pDocName ) {
				*piError = PRINTFILE_ERR_PARAM_DOCNAME;
				goto	EXIT;
			}
		}
	}

	/////////////////////////////////////////////////////////////////////////////
	// (2)  ߃tH_pX̃`FbN
	// 

	if( SFCSSYS_CheckSubFolder( SFCS_SMODE_PRTMIS ) != SFCS_SUCCESS ) {
		*piError = PRINTFILE_ERR_NoMisFolder;
		goto	EXIT;
	}

	/////////////////////////////////////////////////////////////////////////////
	// (3)  ߃tH_pX擾
	// 

	if( !SFCSSYS_GetSubFolder( SFCS_SMODE_PRTMIS, szPrintMisFolder, MAX_PATH + 1 ) ) {
		*piError = PRINTFILE_ERR_GetMisFolder;
		goto	EXIT;
	}

	/////////////////////////////////////////////////////////////////////////////
	// (4)  ꎞt@CpX擾 ydvz
	// 
    //      ߃t@Č`́AINIt@C`Ȃ̂ŁAt@C̏óA
	//    WritePrivateProfileString()yWin32APIz gp܂B
    //    AOSɂAWritePrivateProfileString()yWin32APIz gpĂ
    //    ۂ̃t@Cւ̏õ^C~OقȂׁASTARFAX 
	//    r[ȏԂœǂݏoꂪ܂BhׂɁAUAꎞt@C
	//    쐬Al[悤ɂ܂B
	// 

	if( !GetTempPath( sizeof(szTempFolder), szTempFolder ) ) {
		*piError = PRINTFILE_ERR_GetTempFolder;
		goto	EXIT;
	}
	if( !GetTempFileName( szTempFolder, "SFCS", 0, szTempFile ) ) {
		*piError = PRINTFILE_ERR_GetTempFile;
		goto	EXIT;
	}

	/////////////////////////////////////////////////////////////////////////////
	// (5)  ꎞt@C֏
	// 

	bTemp = TRUE;

	// ZNV: [Doc]       ... e
	// E  Num        ... e
	if( pInfo->iDocNum ) {

		wsprintf( szWork, "%d", pInfo->iDocNum );
		WritePrivateProfileString( "Doc", "Num", szWork, szTempFile );

		// E  Name%d     ... et@CpX  (1`)
		for( i = 0 ;  i < pInfo->iDocNum ; i++ ) {
			pDocName = *( pInfo->ppDocName + i );
			wsprintf( szKey, "Name%d", i + 1 );
			wsprintf( szWork, "\"%s\"", pDocName );
			WritePrivateProfileString( "Doc", szKey, szWork, szTempFile );
		}
	}

	/////////////////////////////////////////////////////////////////////////////
	// (6)  ꎞt@C̃tbV ydvz
	// 
    //      OSɂAWritePrivateProfileString()yWin32APIz gpĂ
    //    ۂ̃t@Cւ̏õ^C~OقȂׁAK̃tbV
	//    XebvKvłB
	// 

	WritePrivateProfileString( NULL, NULL, NULL, szTempFile );

	/////////////////////////////////////////////////////////////////////////////
	// (7)  ߃t@C쐬
	// 

	// ŗL̃t@C쐬
	if( !SFCSSYS_GetUniqFileName( szPrintMisFolder, SFCS_FRM_PRTMIS, szPrintMis ) ) {
		*piError = PRINTFILE_ERR_MakeMisName;
		goto	EXIT;
	}

	/////////////////////////////////////////////////////////////////////////////
	// (8)  ꎞt@C߃t@CɃl[
	// 

	DeleteFile( szPrintMis );	// Ôߍ폜
	MoveFile( szTempFile, szPrintMis );	// l[

	bRet = TRUE;	// I

EXIT:

	// G[́Aꎞt@C폜
	if( bTemp && !bRet ) {
		DeleteFile( szTempFile );
	}

	return bRet;
}

}
